% lab05_ex_partition1.m
% One-level FFT : first FFT sample re-ordering
clear all; close all;

N = 128; x = rand(1,N);                                 % analyzed signal, N=2^p
Xm = fft(x);                                            % its DFT (FFT)
Xe = fft(x(1:2:N));                                     % DFT of "even" samples
Xo = fft(x(2:2:N));                                     % DFT of "odd" samples
X = [ Xe, Xe ] + exp(-j*2*pi/N*(0:1:N-1)) .* [Xo, Xo ]; % combining two DFT spectra
error = max( abs( X - Xm ) ),                           % error